ServerApplications/OWebApplication/Models/AuthController/AuthorizationModel.cs
using System.ComponentModel.DataAnnotations;

namespace OWebApplication.Models.AuthController
{
    public class AuthorizationModel
    {
        [Required, DataType(DataType.EmailAddress), EmailAddress]
        public string Email { get; set; }
        
        [Required, DataType(DataType.Password)]
        public string Password { get; set; }
        
        public bool RememberMe { get; set; }
        
        [DataType(DataType.Text)]
        public string ReturnUrl { get; set; }
    }
}

ServerApplications/OWebApplication/Models/AuthController/RegistrationModel.cs
using System.ComponentModel.DataAnnotations;

namespace OWebApplication.Models.AuthController
{
    public class RegistrationModel
    {
        [Required, MinLength(3), MaxLength(255), DataType(DataType.Text)]
        public string FullName { get; set; }
        [Required, DataType(DataType.EmailAddress), EmailAddress]
        public string Email { get; set; }
        
        [Required, MinLength(8), DataType(DataType.Password)]
        public string Password { get; set; }
        [Required, DataType(DataType.Password), Compare(nameof(Password))]
        public string PasswordRepeat { get; set; }
        
        [Required, DataType(DataType.Text)]
        public string JoinToken { get; set; }
    }
}

ServerApplications/OWebApplication/Controllers/AuthController.cs
using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Localization;
using OWebApplication.Models.AuthController;
using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib;
using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.Identity;

namespace OWebApplication.Controllers
{
    [AllowAnonymous, Route("/Auth")]
    public class AuthController : Controller
    {
        private readonly OvertestDatabaseContext _databaseContext;
        private readonly UserManager<User> _userManager;
        private readonly SignInManager<User> _signInManager;
        private readonly IStringLocalizer<AuthController> _stringLocalizer;
        
        public AuthController(OvertestDatabaseContext databaseContext, UserManager<User> userManager,
            SignInManager<User> signInManager, IStringLocalizer<AuthController> stringLocalizer)
        {
            _databaseContext = databaseContext;
            _userManager = userManager;
            _signInManager = signInManager;
            _stringLocalizer = stringLocalizer;
        }
        
        private new IActionResult View(string name, object model = null) =>
            base.View($"~/Views/AuthController/{name}.cshtml", model);

        [HttpGet, Route(nameof(Authorization))]
        public IActionResult Authorization(string returnUrl = null)
        {
            if (HttpContext.User.Identity is { IsAuthenticated: true })
                return LocalRedirect("/");
            
            return View("Authorization", new AuthorizationModel
            {
                RememberMe = true,
                ReturnUrl = returnUrl
            });
        }
        
        [HttpPost, ValidateAntiForgeryToken, Route(nameof(Authorization))]
        public async Task<IActionResult> Authorization(AuthorizationModel model, string returnUrl = null)
        {
            if (HttpContext.User.Identity is { IsAuthenticated: true })
                return LocalRedirect("/");
            
            const string viewName = "Authorization";

            if (!ModelState.IsValid)
                return View(viewName, model);

            if (returnUrl != model.ReturnUrl)
                return LocalRedirect("/");

            if (!await _databaseContext.Users.AnyAsync(u => u.Email == model.Email.ToLower() && u.IsBanned == false))
            {
                ModelState.AddModelError(nameof(model.Email), _stringLocalizer["Користувача з такими обліковими даними не знаймено, або його заблоковано."]);
                return View(viewName, model);
            }

            var signInResult = await _signInManager.PasswordSignInAsync(model.Email, model.Password, model.RememberMe, false);

            if (!signInResult.Succeeded)
            {
                ModelState.AddModelError(nameof(model.Email), _stringLocalizer["Користувача з такими обліковими даними не знаймено, або його заблоковано."]);
                return View(viewName, model);
            }

            if (string.IsNullOrWhiteSpace(model.ReturnUrl))
                return LocalRedirect("/");
            
            return LocalRedirect(model.ReturnUrl);
        }

        [HttpGet, Route(nameof(Registration) + "/{joinToken?}")]
        public IActionResult Registration(string joinToken = null)
        {
            const string viewName = nameof(Registration);
            
            // Don't allow authenticated users to access this action
            if (HttpContext.User.Identity is { IsAuthenticated: true })
                return LocalRedirect("/");

            return View(viewName, new RegistrationModel
            {
                JoinToken = joinToken
            });
        }

        [HttpPost, ValidateAntiForgeryToken, Route(nameof(Registration) + "/{joinToken?}")]
        public async Task<IActionResult> Registration(RegistrationModel model, string joinToken = null)
        {
            const string viewName = nameof(Registration);
            
            // Don't allow authenticated users to access this action
            if (HttpContext.User.Identity is { IsAuthenticated: true })
                return LocalRedirect("/");

            if (!ModelState.IsValid)
                return View(viewName, model);
            
            if (joinToken != null && model.JoinToken != joinToken)
                model.JoinToken = joinToken;
            
            /*
             * Get information about invite code
             */
            
            // Get information about invite code, specified by the user
            var inviteCodeInfo = await _databaseContext.InviteCodes.AsNoTracking()
                .Where(c => c.Code == model.JoinToken)
                .Select(s => new
                {
                    s.CuratorId,
                    s.Enabled,
                    s.AutoEnableStart,
                    s.AutoEnableEnd
                }).FirstOrDefaultAsync();
            
            // If specified invite code was not found, break the process and inform the user
            if (inviteCodeInfo == null)
            {
                ModelState.AddModelError(nameof(model.JoinToken), _stringLocalizer[
                    "Вказаного вами коду запрошення не знайдено у системі. " +
                    "Зв'яжіться зі своїм куратором, щоб отримати новий код запрошення."]);
                return View(viewName, model);
            }
            
            // We need to save registration time to use it with invite code verification
            var currentUtcTime = DateTime.UtcNow;
            
            // Verify that specified invite code is active now
            var isInviteCodeActive = inviteCodeInfo.Enabled || (
                inviteCodeInfo.AutoEnableStart is not null && inviteCodeInfo.AutoEnableEnd is not null &&
                currentUtcTime >= inviteCodeInfo.AutoEnableStart && currentUtcTime <= inviteCodeInfo.AutoEnableEnd);
            
            // If invite code is expired, inform the user
            if (!isInviteCodeActive)
            {
                ModelState.AddModelError(nameof(model.JoinToken), _stringLocalizer[
                    "Вказаний вами код запрошення неактивний, або період його дії вже сплив. " +
                    "Зв'яжіться зі своїм куратором, щоб отримати новий код запрошення."]);
                return View(viewName, model);
            }
            
            // We allow only registrations with unique email addresses
            if (await _databaseContext.Users.AnyAsync(u => u.Email == model.Email))
            {
                ModelState.AddModelError(nameof(model.Email), _stringLocalizer[
                    "Користувач зі вказаною адресою електронної пошти вже існує у системі! " +
                    "Якщо ви вважаєте, що це - помилка, зв'яжіться зі своїм куратором чи адміністратором системи."]);
                return View(viewName, model);
            }
            
            // Get educational institution name from the curator's profile
            var institutionName = await _databaseContext.Users.AsNoTracking()
                .Where(u => u.Id == inviteCodeInfo.CuratorId)
                .Select(s => s.InstitutionName).FirstAsync();
            
            // Create a new [User] object for our new customer
            var user = new User
            {
                FullName = model.FullName,
                InstitutionName = institutionName,
                
                UserName = model.Email,
                Email = model.Email,

                Type = UserType.Student,
                CuratorId = inviteCodeInfo.CuratorId,

                Registered = currentUtcTime,
                LastSeen = currentUtcTime
            };
            
            // Try to create a new user with specified details and password
            var identityResult = await _userManager.CreateAsync(user, model.Password);
            
            // If we have some problems registering a new account, we need to inform the user
            if (!identityResult.Succeeded)
            {
                ModelState.AddModelError(nameof(model.Email), _stringLocalizer[
                    "На жаль, ми не змогли зареєструвати ваш обліковий запис у системі! " +
                    "Перевірте правильність заповнення реєстраційної форми. " +
                    "Також, одною з причин відмови у реєстрації є надто слабкий пароль."]);
                ModelState.AddModelError(nameof(model.FullName), identityResult.Errors.First().Description);
                return View(viewName, model);
            }
            
            // If everything is OK, try to authenticate the user
            await _signInManager.SignInAsync(user, true);
            
            // Redirect to the Overtest's homepage
            return LocalRedirect("/");
        }

        [Authorize, HttpGet, Route(nameof(LogOut))]
        public IActionResult LogOut() => View(nameof(LogOut));

        [Authorize, HttpPost, ValidateAntiForgeryToken, Route(nameof(LogOut))]
        public async Task<IActionResult> LogOut(bool force)
        {
            await _signInManager.SignOutAsync();
            return LocalRedirect("/");
        }
    }
}

ServerApplications/OWebApplication/Views/AuthController/Authorization.cshtml
@model OWebApplication.Models.AuthController.AuthorizationModel
@{
    ViewBag.PageTitle = Localizer["Авторизація"].Value;
    Layout = "~/Shared/ControllerLayout.cshtml";
}

<style>
    html, body { height: 100%; }
    body {
        display: flex;
        justify-content: center;
        overflow-y: auto;
    }
    
    div#auth-card { width: 90%; height: auto !important; }
    
    @@media (min-width: 768px) {
        div#auth-card { width: 400px; }
    }
</style>

<div class="py-4" id="auth-card">
    <div class="card align-self-center">
        <div class="card-body">
            <h5 class="card-title mb-3">
                <i class="fas fa-campground"></i>
                <span>@Localizer["Вхід у обліковий запис"]</span>
            </h5>
                
            <form method="post" asp-controller="Auth" asp-action="Authorization" asp-route-returnUrl="@Model.ReturnUrl">
                @Html.AntiForgeryToken()
                
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input class="form-control" type="email" asp-for="Email" placeholder="ivan.franko@example.com"/>
                        <label asp-for="Email">@Localizer["Електронна пошта"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.Email)</div>
                </div>
                
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input class="form-control" type="password" asp-for="Password" placeholder="***********"/>
                        <label asp-for="Password">@Localizer["Пароль користувача"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.Password)</div>
                </div>
                
                <div class="form-check form-switch mb-3">
                    <input class="form-check-input" type="checkbox" asp-for="RememberMe">
                    <label class="form-check-label" asp-for="RememberMe">@Localizer["Запам'ятати мене"]</label>
                </div>
                
                @* Actions button group *@
                <div class="d-grid">
                    <div class="btn-group">
                        <button class="btn btn-light btn-lg border" type="submit">
                            <i class="fas fa-fingerprint"></i>
                            <span>@Localizer["Авторизуватися"]</span>
                        </button>
                        <button type="button" class="btn btn-lg btn-light border dropdown-toggle dropdown-toggle-split"
                                style="max-width: 50px;" data-bs-toggle="dropdown"></button>
                        <ul class="dropdown-menu dropdown-menu-end">
                            <li><a class="dropdown-item" asp-controller="Auth" asp-action="Registration">
                                <i class="fas fa-people-carry"></i>
                                <span>@Localizer["Реєстрація"]</span>
                            </a></li>
                            <li><a class="dropdown-item" href="javascript:void(0)" data-bs-toggle="modal" data-bs-target="#passwordResetModal">
                                <i class="fas fa-unlock-alt"></i>
                                <span>@Localizer["Забули пароль?"]</span>
                            </a></li>
                        </ul>
                    </div>
                </div>
                @* /Actions button group *@
            </form>
        </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="passwordResetModal" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">@Localizer["Відновлення доступу"]</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
            </div>
            <div class="modal-body">
                <p class="m-0">@Localizer["Для відновлення доступу до системи у разі втрати облікових даних, будь ласка, зверніться до свого куратора (викладача) або до адміністратора системи."]</p>
            </div>
        </div>
    </div>
</div>

ServerApplications/OWebApplication/Views/AuthController/LogOut.cshtml
@model OWebApplication.Models.AuthController.AuthorizationModel
@{
    ViewBag.PageTitle = Localizer["Вихід з облікового запису"].Value;
    Layout = "~/Shared/ControllerLayout.cshtml";
}

<style>
    html, body { height: 100%; }
    body {
        display: flex;
        justify-content: center;
    }
</style>

<div class="align-self-center text-center">
    <h4>@Localizer["Зачекайте кілька секунд, виконується вихід із системи..."]</h4>
    <form method="post" asp-controller="Auth" asp-action="LogOut" name="logout_form">
        @Html.AntiForgeryToken()
        <button class="btn btn-dark rounded-3"><i class="fas fa-sign-out-alt"></i> @Localizer["Примусовий вихід"]</button>
    </form>
</div>

<script>
    window.onload = function () {
        document.forms['logout_form'].submit();
    }
</script>

ServerApplications/OWebApplication/Views/AuthController/Registration.cshtml
@model OWebApplication.Models.AuthController.RegistrationModel
@{
    ViewBag.PageTitle = Localizer["Реєстрація"].Value;
    Layout = "~/Shared/ControllerLayout.cshtml";
}

<style>
    html, body { height: 100%; }
    body {
        display: flex;
        justify-content: center;
        overflow-y: auto;
    }
    
    div#auth-card { width: 90%; height: auto !important; }
    
    @@media (min-width: 768px) {
        div#auth-card { width: 400px; }
    }
</style>

<div class="py-4" id="auth-card">
    <div class="card align-self-center">
        <div class="card-body">
            <h5 class="card-title mb-3">
                <i class="fas fa-people-carry"></i>
                <span>@Localizer["Реєстрація студента"]</span>
            </h5>
    
            <form method="post" asp-controller="Auth" asp-action="Registration" asp-route-joinToken="@Model.JoinToken">
                @Html.AntiForgeryToken()
                
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input asp-for="FullName" class="form-control" placeholder="@Localizer["Франко Іван Якович"]">
                        <label asp-for="FullName">@Localizer["Ваше повне ім'я"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.FullName)</div>
                </div>
    
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input asp-for="Email" class="form-control" placeholder="@Localizer["ivan.franko@example.com"]">
                        <label asp-for="Email">@Localizer["Електронна пошта"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.Email)</div>
                </div>
    
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input asp-for="Password" class="form-control" placeholder="@Localizer["***********"]">
                        <label asp-for="Password">@Localizer["Вигадайте складний пароль"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.Password)</div>
                </div>
    
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input asp-for="PasswordRepeat" class="form-control" placeholder="@Localizer["***********"]">
                        <label asp-for="PasswordRepeat">@Localizer["Повторіть введення паролю"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.PasswordRepeat)</div>
                </div>
    
                <div class="mb-3">
                    <div class="form-floating m-0">
                        <input asp-for="JoinToken" class="form-control" placeholder="@Localizer["Я люблю Overtest!"]">
                        <label asp-for="JoinToken">@Localizer["Код запрошення"]</label>
                    </div>
                    <div class="form-text text-danger">@Html.ValidationMessageFor(m => m.JoinToken)</div>
                </div>
                
                @* Actions button group *@
                <div class="d-grid">
                    <div class="btn-group">
                        <button class="btn btn-light btn-lg border" type="submit">
                            <i class="fas fa-user-check"></i>
                            <span>@Localizer["Зареєструватися"]</span>
                        </button>
                        <button type="button" class="btn btn-lg btn-light border dropdown-toggle dropdown-toggle-split"
                                style="max-width: 50px;" data-bs-toggle="dropdown"></button>
                        <ul class="dropdown-menu dropdown-menu-end">
                            <li><a class="dropdown-item" asp-controller="Auth" asp-action="Authorization">
                                <i class="fas fa-chevron-circle-left"></i>
                                <span>@Localizer["Маєте обліковий запис?"]</span>
                            </a></li>
                        </ul>
                    </div>
                </div>
                @* /Actions button group *@
            </form>
        </div>
    </div>
</div>